Index: lib/parson.h
===================================================================
--- lib/parson.h	(revision 7a9d9684385640d7e34060469440cc80940465d8)
+++ lib/parson.h	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -0,0 +1,222 @@
+/*
+ Parson ( http://kgabis.github.com/parson/ )
+ Copyright (c) 2012 - 2014 Krzysztof Gabis
+ 
+ Permission is hereby granted, free of charge, to any person obtaining a copy
+ of this software and associated documentation files (the "Software"), to deal
+ in the Software without restriction, including without limitation the rights
+ to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+ 
+ The above copyright notice and this permission notice shall be included in
+ all copies or substantial portions of the Software.
+ 
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ THE SOFTWARE.
+*/
+
+#ifndef parson_parson_h
+#define parson_parson_h
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif    
+    
+#include <stddef.h>   /* size_t */    
+    
+/* Types and enums */
+typedef struct json_object_t JSON_Object;
+typedef struct json_array_t  JSON_Array;
+typedef struct json_value_t  JSON_Value;
+
+typedef long long jint;
+
+enum json_value_type {
+    JSONError   = -1,
+    JSONNull    = 1,
+    JSONString  = 2,
+    JSONInteger = 7,
+    JSONNumber  = 3,
+    JSONObject  = 4,
+    JSONArray   = 5,
+    JSONBoolean = 6
+};
+typedef int JSON_Value_Type;
+    
+enum json_result_t {
+    JSONSuccess = 0,
+    JSONFailure = -1
+};
+typedef int JSON_Status;
+   
+/* Parses first JSON value in a file, returns NULL in case of error */
+JSON_Value * json_parse_file(const char *filename);
+
+/* Parses first JSON value in a file and ignores comments (/ * * / and //),
+   returns NULL in case of error */
+JSON_Value * json_parse_file_with_comments(const char *filename);
+   
+/*  Like json_parse_string, but *end is set to wherever it stopped parsing. */
+JSON_Value * json_parse_first(const char *string, const char **end);
+ 
+/*  Parses first JSON value in a string, returns NULL in case of error */
+JSON_Value * json_parse_string(const char *string);
+
+/*  Parses first JSON value in a string and ignores comments (/ * * / and //),
+    returns NULL in case of error */
+JSON_Value * json_parse_string_with_comments(const char *string);
+    
+/* Serialization */
+size_t      json_serialization_size(const JSON_Value *value);
+JSON_Status json_serialize_to_buffer(const JSON_Value *value, char *buf, size_t buf_size_in_bytes);
+JSON_Status json_serialize_to_file(const JSON_Value *value, const char *filename);
+char *      json_serialize_to_string(const JSON_Value *value);
+void        json_free_serialized_string(char *string); /* frees string from json_serialize_to_string */
+
+/* Comparing */
+int  json_value_equals(const JSON_Value *a, const JSON_Value *b);
+    
+/* Validation
+   This is *NOT* JSON Schema. It validates json by checking if object have identically 
+   named fields with matching types.
+   For example schema {"name":"", "age":0} will validate 
+   {"name":"Joe", "age":25} and {"name":"Joe", "age":25, "gender":"m"},
+   but not {"name":"Joe"} or {"name":"Joe", "age":"Cucumber"}.
+   In case of arrays, only first value in schema is checked against all values in tested array.
+   Empty objects ({}) validate all objects, empty arrays ([]) validate all arrays,
+   null validates values of every type.
+ */
+JSON_Status json_validate(const JSON_Value *schema, const JSON_Value *value);
+    
+/*
+ * JSON Object
+ */
+JSON_Value  * json_object_get_value  (const JSON_Object *object, const char *name);
+const char  * json_object_get_string (const JSON_Object *object, const char *name);
+JSON_Object * json_object_get_object (const JSON_Object *object, const char *name);
+JSON_Array  * json_object_get_array  (const JSON_Object *object, const char *name);
+jint          json_object_get_integer(const JSON_Object *object, const char *name); /* returns 0 on fail */
+double        json_object_get_number (const JSON_Object *object, const char *name); /* returns 0 on fail */
+int           json_object_get_boolean(const JSON_Object *object, const char *name); /* returns -1 on fail */
+
+/* dotget functions enable addressing values with dot notation in nested objects,
+ just like in structs or c++/java/c# objects (e.g. objectA.objectB.value).
+ Because valid names in JSON can contain dots, some values may be inaccessible
+ this way. */
+JSON_Value  * json_object_dotget_value  (const JSON_Object *object, const char *name);
+const char  * json_object_dotget_string (const JSON_Object *object, const char *name);
+JSON_Object * json_object_dotget_object (const JSON_Object *object, const char *name);
+JSON_Array  * json_object_dotget_array  (const JSON_Object *object, const char *name);
+jint          json_object_dotget_integer(const JSON_Object *object, const char *name); /* returns 0 on fail */
+double        json_object_dotget_number (const JSON_Object *object, const char *name); /* returns 0 on fail */
+int           json_object_dotget_boolean(const JSON_Object *object, const char *name); /* returns -1 on fail */
+
+/* Functions to get available names */
+size_t        json_object_get_count(const JSON_Object *object);
+const char  * json_object_get_name (const JSON_Object *object, size_t index);
+int           json_object_get_tuple(const JSON_Object *object, size_t index,
+                                    const char **key, const JSON_Value **value); /* 0 == fail */
+
+/* Creates new name-value pair or frees and replaces old value with new one. */
+JSON_Status json_object_set_value(JSON_Object *object, const char *name, JSON_Value *value);
+JSON_Status json_object_set_string(JSON_Object *object, const char *name, const char *string);
+JSON_Status json_object_set_integer(JSON_Object *object, const char *name, jint number);
+JSON_Status json_object_set_number(JSON_Object *object, const char *name, double number);
+JSON_Status json_object_set_boolean(JSON_Object *object, const char *name, int boolean);
+JSON_Status json_object_set_null(JSON_Object *object, const char *name);
+
+/* Works like dotget functions, but creates whole hierarchy if necessary. */
+JSON_Status json_object_dotset_value(JSON_Object *object, const char *name, JSON_Value *value);
+JSON_Status json_object_dotset_string(JSON_Object *object, const char *name, const char *string);
+JSON_Status json_object_dotset_integer(JSON_Object *object, const char *name, jint number);
+JSON_Status json_object_dotset_number(JSON_Object *object, const char *name, double number);
+JSON_Status json_object_dotset_boolean(JSON_Object *object, const char *name, int boolean);
+JSON_Status json_object_dotset_null(JSON_Object *object, const char *name);
+
+/* Frees and removes name-value pair */
+JSON_Status json_object_remove(JSON_Object *object, const char *name);
+
+/* Works like dotget function, but removes name-value pair only on exact match. */
+JSON_Status json_object_dotremove(JSON_Object *object, const char *key);
+
+/* Removes all name-value pairs in object */
+JSON_Status json_object_clear(JSON_Object *object);
+    
+/* 
+ *JSON Array 
+ */
+JSON_Value  * json_array_get_value  (const JSON_Array *array, size_t index);
+const char  * json_array_get_string (const JSON_Array *array, size_t index);
+JSON_Object * json_array_get_object (const JSON_Array *array, size_t index);
+JSON_Array  * json_array_get_array  (const JSON_Array *array, size_t index);
+jint          json_array_get_integer(const JSON_Array *array, size_t index); /* returns 0 on fail */
+double        json_array_get_number (const JSON_Array *array, size_t index); /* returns 0 on fail */
+int           json_array_get_boolean(const JSON_Array *array, size_t index); /* returns -1 on fail */
+size_t        json_array_get_count  (const JSON_Array *array);
+    
+/* Frees and removes value at given index, does nothing and returns JSONFailure if index doesn't exist.
+ * Order of values in array may change during execution.  */
+JSON_Status json_array_remove(JSON_Array *array, size_t i);
+
+/* Frees and removes from array value at given index and replaces it with given one.
+ * Does nothing and returns JSONFailure if index doesn't exist. */
+JSON_Status json_array_replace_value(JSON_Array *array, size_t i, JSON_Value *value);
+JSON_Status json_array_replace_string(JSON_Array *array, size_t i, const char* string);
+JSON_Status json_array_replace_integer(JSON_Array *array, size_t i, jint number);
+JSON_Status json_array_replace_number(JSON_Array *array, size_t i, double number);
+JSON_Status json_array_replace_boolean(JSON_Array *array, size_t i, int boolean);
+JSON_Status json_array_replace_null(JSON_Array *array, size_t i);
+
+/* Frees and removes all values from array */
+JSON_Status json_array_clear(JSON_Array *array);
+
+/* Appends new value at the end of array. */
+JSON_Status json_array_append_value(JSON_Array *array, JSON_Value *value);
+JSON_Status json_array_append_string(JSON_Array *array, const char *string);
+JSON_Status json_array_append_integer(JSON_Array *array, jint number);
+JSON_Status json_array_append_number(JSON_Array *array, double number);
+JSON_Status json_array_append_boolean(JSON_Array *array, int boolean);
+JSON_Status json_array_append_null(JSON_Array *array);
+    
+/*
+ *JSON Value
+ */
+JSON_Value * json_value_init_object (void);
+JSON_Value * json_value_init_array  (void);
+JSON_Value * json_value_init_string (const char *string); /* copies passed string */
+JSON_Value * json_value_init_integer(jint number);
+JSON_Value * json_value_init_number (double number);
+JSON_Value * json_value_init_boolean(int boolean);
+JSON_Value * json_value_init_null   (void);
+JSON_Value * json_value_deep_copy   (const JSON_Value *value);
+void         json_value_free        (JSON_Value *value);
+
+JSON_Value_Type json_value_get_type   (const JSON_Value *value);
+JSON_Object *   json_value_get_object (const JSON_Value *value);
+JSON_Array  *   json_value_get_array  (const JSON_Value *value);
+const char  *   json_value_get_string (const JSON_Value *value);
+jint            json_value_get_integer(const JSON_Value *value);
+double          json_value_get_number (const JSON_Value *value);
+int             json_value_get_boolean(const JSON_Value *value);
+
+/* Same as above, but shorter */
+JSON_Value_Type json_type   (const JSON_Value *value);
+JSON_Object *   json_object (const JSON_Value *value);
+JSON_Array  *   json_array  (const JSON_Value *value);
+const char  *   json_string (const JSON_Value *value);
+jint            json_integer(const JSON_Value *value);
+double          json_number (const JSON_Value *value);
+int             json_boolean(const JSON_Value *value);
+    
+#ifdef __cplusplus
+}
+#endif
+
+#endif
Index: protocols/account.c
===================================================================
--- protocols/account.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ protocols/account.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -27,8 +27,4 @@
 #include "bitlbee.h"
 #include "account.h"
-
-static const char* account_protocols_local[] = {
-	"gg", "whatsapp", NULL
-};
 
 static char *set_eval_nick_source(set_t *set, char *value);
@@ -469,14 +465,2 @@
 	return a->auto_reconnect_delay;
 }
-
-int protocol_account_islocal(const char* protocol)
-{
-	const char** p = account_protocols_local;
-
-	do {
-		if (strcmp(*p, protocol) == 0) {
-			return 1;
-		}
-	} while (*(++p));
-	return 0;
-}
Index: protocols/account.h
===================================================================
--- protocols/account.h	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ protocols/account.h	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -58,6 +58,4 @@
 int account_reconnect_delay(account_t *a);
 
-int protocol_account_islocal(const char* protocol);
-
 typedef enum {
 	ACC_SET_OFFLINE_ONLY = 0x02,    /* Allow changes only if the acct is offline. */
@@ -70,5 +68,5 @@
 	ACC_FLAG_STATUS_MESSAGE = 0x02, /* Supports status messages (without being away). */
 	ACC_FLAG_HANDLE_DOMAINS = 0x04, /* Contact handles need a domain portion. */
-	ACC_FLAG_LOCAL = 0x08,          /* Contact list is local. */
+	ACC_FLAG_LOCAL_CONTACTS = 0x08, /* Contact list is local. */
 	ACC_FLAG_LOCKED = 0x10,         /* Account is locked (cannot be deleted, certain settings can't changed) */
 } account_flag_t;
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ protocols/nogaim.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -259,4 +259,5 @@
 	extern void twitter_initmodule();
 	extern void purple_initmodule();
+	extern void rpc_initmodule();
 
 #ifdef WITH_MSN
@@ -278,4 +279,8 @@
 #ifdef WITH_PURPLE
 	purple_initmodule();
+#endif
+
+#ifdef WITH_RPC
+	rpc_initmodule();
 #endif
 
@@ -443,10 +448,12 @@
 	}
 
-	if (ic->acc->flags & ACC_FLAG_LOCAL) {
+	if ((ic->acc->flags & ACC_FLAG_LOCAL_CONTACTS) &&
+	    !(ic->flags & OPT_LOCAL_CONTACTS_SENT) &&
+	    ic->acc->prpl->add_buddy) {
 		GHashTableIter nicks;
-		gpointer k, v;
+		gpointer handle;
 		g_hash_table_iter_init(&nicks, ic->acc->nicks);
-		while (g_hash_table_iter_next(&nicks, &k, &v)) {
-			ic->acc->prpl->add_buddy(ic, (char *) k, NULL);
+		while (g_hash_table_iter_next(&nicks, &handle, NULL)) {
+			ic->acc->prpl->add_buddy(ic, (char *) handle, NULL);
 		}
 	}
@@ -543,4 +550,13 @@
 	query_del_by_conn((irc_t *) ic->bee->ui_data, ic);
 
+	/* Throw away groupchats owned by this account. Historically this was only
+	   ever done by IM modules which is a bug. But it gives them opportunity
+	   to clean up protocol-specific bits as well so keep it that way, just
+	   do another cleanup here as a fallback. Don't want to leave any dangling
+	   pointers! */
+	while (ic->groupchats) {
+		imcb_chat_free(ic->groupchats->data);
+	}
+
 	if (!a) {
 		/* Uhm... This is very sick. */
@@ -641,4 +657,33 @@
 }
 
+/* Returns the local contacts for an IM account (based on assigned nicks).
+   Linked list should be freed, the strings themselves not! So look at it
+   like a GSList<const char*> I guess? Empty list means NULL retval (as
+   always with GSList). */
+GSList *imcb_get_local_contacts(struct im_connection *ic)
+{
+ 	GHashTableIter nicks;
+	GSList *ret = NULL;
+	
+	if (!(ic->acc->flags & ACC_FLAG_LOCAL_CONTACTS)) {
+		/* Only allow protocols that indicate local contact list
+		   support to use this function. */
+		return ret;
+	}
+	
+	g_hash_table_iter_init(&nicks, ic->acc->nicks);
+	gpointer handle;
+	while (g_hash_table_iter_next(&nicks, &handle, NULL)) {
+		ret = g_slist_prepend(ret, (char *) handle);
+	}
+	
+	/* If the protocol asked for the list, assume we won't have to send it
+	   anymore in imcb_connected(). */
+	ic->flags |= OPT_LOCAL_CONTACTS_SENT;
+	
+	return ret;
+}
+
+
 struct imcb_ask_cb_data {
 	struct im_connection *ic;
@@ -698,5 +743,7 @@
 	struct imcb_ask_cb_data *cbd = data;
 
-	cbd->ic->acc->prpl->add_buddy(cbd->ic, cbd->handle, NULL);
+	if (cbd->ic->acc->prpl->add_buddy) {
+		cbd->ic->acc->prpl->add_buddy(cbd->ic, cbd->handle, NULL);
+	}
 
 	imcb_ask_cb_free(data);
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ protocols/nogaim.h	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -57,5 +57,10 @@
 
 /* Sharing flags between all kinds of things. I just hope I won't hit any
-   limits before 32-bit machines become extinct. ;-) */
+   limits before 32-bit machines become extinct. ;-)
+   
+   Argh! This needs to be renamed to be more clear which field they're used
+   for. As said it's currently mixed which is nonsense. Some are for the
+   im_connection flags field, some for imcb_buddy_status(), some for typing
+   notifications, and who knows what else... */
 #define OPT_LOGGED_IN   0x00000001
 #define OPT_LOGGING_OUT 0x00000002
@@ -70,4 +75,5 @@
 #define OPT_PONGS       0x00010000 /* Service sends us keep-alives */
 #define OPT_PONGED      0x00020000 /* Received a keep-alive during last interval */
+#define OPT_LOCAL_CONTACTS_SENT 0x00040000 /* Protocol already requested local contact list, so don't send it after finishing login. */
 #define OPT_SELFMESSAGE 0x00080000 /* A message sent by self from another location */
 
@@ -372,4 +378,5 @@
 G_MODULE_EXPORT void imcb_buddy_nick_change(struct im_connection *ic, const char *handle, const char *nick);
 G_MODULE_EXPORT void imcb_buddy_action_response(bee_user_t *bu, const char *action, char * const args[], void *data);
+G_MODULE_EXPORT GSList *imcb_get_local_contacts(struct im_connection *ic);
 
 G_MODULE_EXPORT void imcb_buddy_typing(struct im_connection *ic, const char *handle, guint32 flags);
Index: protocols/purple/purple.c
===================================================================
--- protocols/purple/purple.c	(revision 4a9c6b0b15eb3738897dc1635fda2e4be67414ad)
+++ protocols/purple/purple.c	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -327,4 +327,9 @@
 	}
 	purple_accounts_remove(pa);
+	
+	/* Last, some protocols want their contact lists locally. */
+	if (strcmp(acc->prpl->name, "whatsapp") == 0 || strcmp(acc->prpl->name, "gg") == 0) {
+		acc->flags |= ACC_FLAG_LOCAL_CONTACTS;
+	}
 }
 
Index: protocols/rpc/Makefile
===================================================================
--- protocols/rpc/Makefile	(revision 7a9d9684385640d7e34060469440cc80940465d8)
+++ protocols/rpc/Makefile	(revision 7a9d9684385640d7e34060469440cc80940465d8)
@@ -0,0 +1,46 @@
+###########################
+## Makefile for BitlBee  ##
+##                       ##
+## Copyright 2002 Lintux ##
+###########################
+
+### DEFINITIONS
+
+-include ../../Makefile.settings
+ifdef _SRCDIR_
+_SRCDIR_ := $(_SRCDIR_)protocols/rpc/
+endif
+
+# [SH] Program variables
+objects = rpc.o
+
+LFLAGS += -r
+
+# [SH] Phony targets
+all: rpc_mod.o
+check: all
+lcov: check
+gcov: 
+	gcov *.c
+	
+.PHONY: all clean distclean
+
+clean:
+	rm -f *.o core
+
+distclean: clean
+	rm -rf .depend
+
+### MAIN PROGRAM
+
+$(objects): ../../Makefile.settings Makefile
+
+$(objects): %.o: $(_SRCDIR_)%.c
+	@echo '*' Compiling $<
+	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+
+rpc_mod.o: $(objects)
+	@echo '*' Linking rpc_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o rpc_mod.o
+	
+-include .depend/*.d
